<?php

namespace Drupal\visitors\Plugin\views\sort;

use Drupal\views\Plugin\views\sort\SortPluginBase;

/**
 * Default implementation of the base sort plugin.
 *
 * @ingroup views_sort_handlers
 *
 * @ViewsSort("visitors_browser_version")
 */
class BrowserVersion extends SortPluginBase {

  /**
   * Called to add the sort to a query.
   */
  public function query() {
    $this->ensureMyTable();

    // Order by another field first.
    $this->query->addOrderBy($this->tableAlias, 'config_browser_name', $this->options['order']);
    // Add the field.
    $this->query->addOrderBy($this->tableAlias, $this->realField, $this->options['order']);
  }

}
